//******************************************************************************
// WIN_02.cpp - ffnet eine eigene Client-Area und gibt dort einen Text aus
//******************************************************************************
#include <windows.h>

LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM);

LRESULT fnWMDestroy (HWND, WPARAM, LPARAM);
LRESULT fnWMPaint   (HWND, WPARAM, LPARAM);

const char sWindowclassname [] = "Win_02";
HWND       hWindow;

//==============================================================================
// Hauptprogramm
//==============================================================================
#pragma argsused
WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdParam,
                    int nCmdShow)
{
   MSG      aMessage;
   WNDCLASS aWindowclass;

   if (!hPrevInstance)
   {
      aWindowclass.style         = CS_HREDRAW | CS_VREDRAW;
      aWindowclass.lpfnWndProc   = WndProc;
      aWindowclass.cbClsExtra    = 0;
      aWindowclass.cbWndExtra    = 0;
      aWindowclass.hInstance     = hInstance;
      aWindowclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION);
      aWindowclass.hCursor       = LoadCursor (NULL, IDC_ARROW);
      aWindowclass.hbrBackground = (HBRUSH) GetStockObject (WHITE_BRUSH);
      aWindowclass.lpszMenuName  = NULL;
      aWindowclass.lpszClassName = sWindowclassname;

      if (!RegisterClass (&aWindowclass))
      {
         MessageBox (NULL,"Registrierung nicht mglich",sWindowclassname,MB_OK);
         return 0;
      }
   }

   //---------------------------------------------------------------------------
   hWindow = CreateWindow (sWindowclassname, "Umrechner", WS_OVERLAPPEDWINDOW,
                           CW_USEDEFAULT, CW_USEDEFAULT,
                           CW_USEDEFAULT, CW_USEDEFAULT,
                           NULL, NULL, hInstance, NULL);
   if (!hWindow)
   {
      MessageBox (NULL, "Fenster nicht erzeugbar", sWindowclassname, MB_OK);
      return 0;
   }

   //---------------------------------------------------------------------------
   ShowWindow (hWindow, nCmdShow);
   if (!UpdateWindow (hWindow))
   {
      MessageBox (NULL, "WM_PAINT fehlgeschlagen", sWindowclassname, MB_OK);
      return 0;
   }

   //---------------------------------------------------------------------------
   while (GetMessage (&aMessage, NULL, 0, 0))
   {
      TranslateMessage (&aMessage);
      DispatchMessage (&aMessage);
   }
   return aMessage.wParam;
}

//==============================================================================
// Handlerfunktion der Client-Area, wird von DispatchMessage aufgerufen.
//==============================================================================
#pragma argsused
LRESULT CALLBACK WndProc (HWND hWnd, UINT nMsg, WPARAM wParam, LPARAM lParam)
{
   switch (nMsg)
   {
      case WM_PAINT:   return fnWMPaint   (hWnd, wParam, lParam);
      case WM_DESTROY: return fnWMDestroy (hWnd, wParam, lParam);
   }
   return DefWindowProc (hWnd, nMsg, wParam, lParam);
}

//==============================================================================
// Funktion der Client-Area, wird von WndProc aufgerufen
//==============================================================================
#pragma argsused
LRESULT fnWMPaint (HWND hWnd, WPARAM wParam, LPARAM lParam)
{
   HDC         hDC ;
   PAINTSTRUCT aPS ;
   RECT        aRect ;

   GetClientRect (hWnd, &aRect);
   hDC = BeginPaint (hWnd, &aPS);
   DrawText (hDC, "Umrechnung", -1, &aRect,
             DT_SINGLELINE | DT_CENTER | DT_VCENTER);
   EndPaint (hWnd, &aPS);
   return 0;
}

//==============================================================================
// Funktion der Client-Area, wird von WndProc aufgerufen
//==============================================================================
#pragma argsused
LRESULT fnWMDestroy (HWND hWnd, WPARAM wParam, LPARAM lParam)
{
   PostQuitMessage (0);
   return 0;
}
