//******************************************************************************
// WIN_03.cpp - ffnet eine eigene Client-Area und gibt dort einen Text aus
//******************************************************************************
#include <windows.h>
#include <dos.h>
#include <stdio.h>

LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM);

LRESULT fnWMDestroy (HWND, WPARAM, LPARAM);
LRESULT fnWMPaint   (HWND, WPARAM, LPARAM);
LRESULT fnWMTimer   (HWND, WPARAM, LPARAM);

#define ID_TIMER    10000

const char sWindowclassname [] = "Win_03";
HWND       hWindow;

//==============================================================================
// Hauptprogramm
//==============================================================================
#pragma argsused
WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdParam,
                    int nCmdShow)
{
   MSG         aMessage;
   WNDCLASS    aWindowclass;

   if (!hPrevInstance)
   {
      aWindowclass.style         = CS_HREDRAW | CS_VREDRAW;
      aWindowclass.lpfnWndProc   = WndProc;
      aWindowclass.cbClsExtra    = 0;
      aWindowclass.cbWndExtra    = 0;
      aWindowclass.hInstance     = hInstance;
      aWindowclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION);
      aWindowclass.hCursor       = LoadCursor (NULL, IDC_ARROW);
      aWindowclass.hbrBackground = (HBRUSH) GetStockObject (WHITE_BRUSH);
      aWindowclass.lpszMenuName  = NULL;
      aWindowclass.lpszClassName = sWindowclassname;

      if (!RegisterClass (&aWindowclass))
      {
         MessageBox (NULL,"Registrierung nicht mglich",sWindowclassname,MB_OK);
         return 0;
      }
   }

   //---------------------------------------------------------------------------
   hWindow = CreateWindow (sWindowclassname, "Umrechner", WS_OVERLAPPEDWINDOW,
                           CW_USEDEFAULT, CW_USEDEFAULT,
                           CW_USEDEFAULT, CW_USEDEFAULT,
                           NULL, NULL, hInstance, NULL);
   if (!hWindow)
   {
      MessageBox (NULL, "Fenster nicht erzeugbar", sWindowclassname, MB_OK);
      return 0;
   }

   //---------------------------------------------------------------------------
   if (!SetTimer (hWindow, ID_TIMER, 1000, NULL))
   {
      MessageBox (hWindow, "Zuviele Timer!", sWindowclassname,
                  MB_ICONEXCLAMATION | MB_RETRYCANCEL);
      return 0;
   }

   //---------------------------------------------------------------------------
   ShowWindow (hWindow, nCmdShow);
   if (!UpdateWindow (hWindow))
   {
      MessageBox (NULL, "WM_PAINT fehlgeschlagen", sWindowclassname, MB_OK);
      return 0;
   }

   //---------------------------------------------------------------------------
   while (GetMessage (&aMessage, NULL, 0, 0))
   {
      TranslateMessage (&aMessage);
      DispatchMessage (&aMessage);
   }
   return aMessage.wParam;
}

//==============================================================================
// Handlerfunktion der Client-Area, wird von DispatchMessage aufgerufen.
//==============================================================================
#pragma argsused
LRESULT CALLBACK WndProc (HWND hWnd, UINT nMsg, WPARAM wParam, LPARAM lParam)
{
   switch (nMsg)
   {
   	  case WM_TIMER:   return fnWMTimer   (hWnd, wParam, lParam);
      case WM_PAINT:   return fnWMPaint   (hWnd, wParam, lParam);
      case WM_DESTROY: return fnWMDestroy (hWnd, wParam, lParam);
   }
   return DefWindowProc (hWnd, nMsg, wParam, lParam);
}

//==============================================================================
// Funktion der Client-Area, wird von WndProc aufgerufen
//==============================================================================
#pragma argsused
LRESULT fnWMPaint (HWND hWnd, WPARAM wParam, LPARAM lParam)
{
   HDC         hDC ;
   PAINTSTRUCT aPS ;
   RECT        aRect ;

   char sTime [10] = "";
   struct time aTime;

   gettime(&aTime);
   sprintf (sTime, "%02d:%02d.%02d", aTime.ti_hour, aTime.ti_min, aTime.ti_sec);

   GetClientRect (hWnd, &aRect);
   hDC = BeginPaint (hWnd, &aPS);
   DrawText (hDC, "Umrechnung", -1, &aRect, DT_SINGLELINE | DT_CENTER | DT_TOP);
   DrawText (hDC, sTime, -1, &aRect, DT_SINGLELINE | DT_RIGHT | DT_BOTTOM);
   EndPaint (hWnd, &aPS);
   return 0;
}

//==============================================================================
// Funktion der Client-Area, wird von WndProc aufgerufen
//==============================================================================
#pragma argsused
LRESULT fnWMDestroy (HWND hWnd, WPARAM wParam, LPARAM lParam)
{
   PostQuitMessage (0);
   KillTimer (hWnd, ID_TIMER);
   return 0;
}

//==============================================================================
// Funktion der Client-Area, wird von WndProc aufgerufen
//==============================================================================
#pragma argsused
LRESULT fnWMTimer (HWND hWnd, WPARAM wParam, LPARAM lParam)
{
  MessageBeep (0);    
  InvalidateRect (hWnd, NULL, TRUE);
  return 0;
}
