//******************************************************************************
// WIN_11.cpp - ffnet eine eigene Client-Area und gibt dort einen Text aus
//******************************************************************************
#include <windows.h>
#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include "Win_11.rh"
#include <condefs.h> // spezifisch: Borland C++ Builder

//==============================================================================
// Funktionsprototypen
//==============================================================================
USERC("Win_11.rc"); // spezifisch: Borland C++ Builder
//---------------------------------------------------------------------------
LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM);

LRESULT fnWMCommand (HWND, WPARAM, LPARAM);
LRESULT fnWMCreate  (HWND, WPARAM, LPARAM);
LRESULT fnWMDestroy (HWND, WPARAM, LPARAM);
LRESULT fnWMPaint   (HWND, WPARAM, LPARAM);
LRESULT fnWMSize    (HWND, WPARAM, LPARAM);
LRESULT fnWMTimer   (HWND, WPARAM, LPARAM);

//------------------------------------------------------------------------------
void   fnValueTable (HDC hDC);
double fnCalcValue  (double fValue, double fFaktor=1.0, bool bMultiply=true,
                     double fOffset=0.0, bool bAddOffset=false,
                     bool bOffsetFirst=true);

//==============================================================================
// Symbolische Konstanten
//==============================================================================
#define ID_TIMER    10000
#define ID_STATIC_1 10001

#define EINHEITTEXTLEN 100

//==============================================================================
// globale Variablen
//==============================================================================
int nAnzZeichen, nAnzZeilen;
int nSmallCharWidth, nBigCharWidth, nCharHeight;
char sEinheit1 [EINHEITTEXTLEN] = "Zoll";
char sEinheit2 [EINHEITTEXTLEN] = "cm";
double fFaktor       = 2.56;
bool   bMultiply     = true;
double fOffset       = 0.0;
bool   bAddOffset    = false;
bool   bOffsetFirst  = false;
double fSchrittweite = 1.0;
double fStartwert    = 0.0;
int    nStellenVK    =  10;
int    nStellenNK    =   2;

const char sWindowclassname [] = "Win_11";
HWND       hWindow;
HWND       hStatic_1;

//==============================================================================
// Hauptprogramm
//==============================================================================
#pragma argsused
WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdParam,
                    int nCmdShow)
{
   MSG      aMessage;
   WNDCLASS aWindowclass;

   if (!hPrevInstance)
   {
      aWindowclass.style         = CS_HREDRAW | CS_VREDRAW;
      aWindowclass.lpfnWndProc   = WndProc;
      aWindowclass.cbClsExtra    = 0;
      aWindowclass.cbWndExtra    = 0;
      aWindowclass.hInstance     = hInstance;
      aWindowclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION);
      aWindowclass.hCursor       = LoadCursor (NULL, IDC_ARROW);
      aWindowclass.hbrBackground = (HBRUSH) GetStockObject (WHITE_BRUSH);
      aWindowclass.lpszMenuName  = MAKEINTRESOURCE(IDM_MENU1);
      aWindowclass.lpszClassName = sWindowclassname;

      if (!RegisterClass (&aWindowclass))
      {
         MessageBox (NULL,"Registrierung nicht mglich",sWindowclassname,MB_OK);
         return 0;
      }
   }

   //---------------------------------------------------------------------------
   hWindow = CreateWindow (sWindowclassname, "Umrechner", WS_OVERLAPPEDWINDOW,
                           CW_USEDEFAULT, CW_USEDEFAULT,
                           CW_USEDEFAULT, CW_USEDEFAULT,
                           NULL, NULL, hInstance, NULL);
   if (!hWindow)
   {
      MessageBox (NULL, "Fenster nicht erzeugbar", sWindowclassname, MB_OK);
      return 0;
   }

   //---------------------------------------------------------------------------
   if (!SetTimer (hWindow, ID_TIMER, 1000, NULL))
   {
      MessageBox (hWindow, "Zuviele Timer!", sWindowclassname,
                  MB_ICONEXCLAMATION | MB_RETRYCANCEL);
      return 0;
   }

   //---------------------------------------------------------------------------
   ShowWindow (hWindow, nCmdShow);
   if (!UpdateWindow (hWindow))
   {
      MessageBox (NULL, "WM_PAINT fehlgeschlagen", sWindowclassname, MB_OK);
      return 0;
   }

   //---------------------------------------------------------------------------
   while (GetMessage (&aMessage, NULL, 0, 0))
   {
      TranslateMessage (&aMessage);
      DispatchMessage (&aMessage);
   }
   return aMessage.wParam;
}

//==============================================================================
// Handlerfunktion der Client-Area, wird von DispatchMessage aufgerufen.
//==============================================================================
#pragma argsused
LRESULT CALLBACK WndProc (HWND hWnd, UINT nMsg, WPARAM wParam, LPARAM lParam)
{
   switch (nMsg)
   {
      case WM_COMMAND: return fnWMCommand (hWnd, wParam, lParam);
      case WM_CREATE:  return fnWMCreate  (hWnd, wParam, lParam);
      case WM_DESTROY: return fnWMDestroy (hWnd, wParam, lParam);
      case WM_PAINT:   return fnWMPaint   (hWnd, wParam, lParam);
   	  case WM_SIZE:    return fnWMSize    (hWnd, wParam, lParam);
   	  case WM_TIMER:   return fnWMTimer   (hWnd, wParam, lParam);
   }
   return DefWindowProc (hWnd, nMsg, wParam, lParam);
}

//==============================================================================
// Funktion der Client-Area, wird von WndProc aufgerufen
//==============================================================================
#pragma argsused
LRESULT fnWMPaint (HWND hWnd, WPARAM wParam, LPARAM lParam)
{
   HDC         hDC ;
   PAINTSTRUCT aPS ;
   RECT        aRectTitel;
   char        sUeberschrift [2*EINHEITTEXTLEN + 50];
   HBRUSH      hBlueBrush;
   HFONT       hFont, hOldFont;
   int         nOldBk;
   COLORREF    nOldTxtCol;

   //---------------------------------------------------------------------------
   // berschrift
   //---------------------------------------------------------------------------
   GetClientRect (hWnd, &aRectTitel);
   aRectTitel.bottom = aRectTitel.top + 1.5 * nCharHeight;
   hBlueBrush = CreateSolidBrush (RGB (100, 100, 255));
   hFont      = CreateFont (nCharHeight, 0, 0, 0, FW_THIN, FALSE, FALSE, FALSE,
                            ANSI_CHARSET, OUT_DEFAULT_PRECIS,
                            CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
                            DEFAULT_PITCH, "Braggadocio");
   sprintf (sUeberschrift, "Umrechnung von %s nach %s", sEinheit1, sEinheit2);

   //---------------------------------------------------------------------------
   hDC = BeginPaint (hWnd, &aPS);

   FillRect (hDC, &aRectTitel, hBlueBrush);
   FrameRect(hDC, &aRectTitel, (HBRUSH)GetStockObject (BLACK_BRUSH));

   hOldFont   = (HFONT)SelectObject (hDC, hFont);
   nOldBk     = SetBkMode (hDC, TRANSPARENT);
   nOldTxtCol = SetTextColor (hDC, RGB (255,255,0));
   DrawText (hDC, sUeberschrift, -1, &aRectTitel, DT_SINGLELINE|DT_CENTER|DT_VCENTER);
   SetTextColor (hDC, nOldTxtCol);
   SetBkMode    (hDC, nOldBk);
   SelectObject (hDC, hOldFont);

   fnValueTable(hDC);
   EndPaint (hWnd, &aPS);

   //---------------------------------------------------------------------------
   // Limitierte Resourcen wieder freigeben
   //---------------------------------------------------------------------------
   DeleteObject (hBlueBrush);
   DeleteObject (hFont);

   return 0;
}

//==============================================================================
// Funktion der Client-Area, wird von WndProc aufgerufen
//==============================================================================
#pragma argsused
LRESULT fnWMCommand (HWND hWnd, WPARAM wParam, LPARAM lParam)
{
  WORD wID = LOWORD(wParam);
  switch (wID)
  {
    case  IDM_ZOLLCM:
          strcpy (sEinheit1, "Zoll");
          strcpy (sEinheit2, "cm");
          fFaktor      = 2.56;
          bMultiply    = true;
          fOffset      = 0.0;
          bAddOffset   = false;
          bOffsetFirst = false;
          InvalidateRect (hWnd, NULL, TRUE);
          return 0;

    case  IDM_CMZOLL:
          strcpy (sEinheit1, "cm");
          strcpy (sEinheit2, "Zoll");
          fFaktor      = 2.56;
          bMultiply    = false;
          fOffset      = 0.0;
          bAddOffset   = false;
          bOffsetFirst = false;
          InvalidateRect (hWnd, NULL, TRUE);
          return 0;

    case  IDM_CELSIUSFAHRENHEIT:
          strcpy (sEinheit1, "Celsius");
          strcpy (sEinheit2, "Fahrenheit");
          fFaktor      = 5.0/9.0;
          bMultiply    = false;
          fOffset      = 32.0;
          bAddOffset   = true;
          bOffsetFirst = false;
          InvalidateRect (hWnd, NULL, TRUE);
          return 0;

    case  IDM_FAHRENHEITCELSIUS:
          strcpy (sEinheit1, "Fahrenheit");
          strcpy (sEinheit2, "Celsius");
          fFaktor      = 5.0/9.0;
          bMultiply    = true;
          fOffset      = 32.0;
          bAddOffset   = false;
          bOffsetFirst = true;
          InvalidateRect (hWnd, NULL, TRUE);
          return 0;
  }
  return DefWindowProc (hWnd, WM_COMMAND, wParam, lParam);
}

//==============================================================================
// Funktion der Client-Area, wird von WndProc aufgerufen
//==============================================================================
#pragma argsused
LRESULT fnWMCreate (HWND hWnd, WPARAM wParam, LPARAM lParam)
{
   TEXTMETRIC aTM;

   HDC hDC = GetDC (hWnd) ;
   GetTextMetrics (hDC, &aTM) ;
   ReleaseDC (hWnd, hDC) ;

   nCharHeight     = aTM.tmHeight + aTM.tmExternalLeading;
   nSmallCharWidth = aTM.tmAveCharWidth;
   nBigCharWidth   = (aTM.tmPitchAndFamily & TMPF_FIXED_PITCH ? 3 : 2) *
                      aTM.tmAveCharWidth / 2;

   hStatic_1 = CreateWindow ("static", "Uhrzeit",
                             WS_CHILD | WS_VISIBLE | SS_RIGHT,
                             0, 0, 0, 0, hWnd, (HMENU)ID_STATIC_1,
                             (HINSTANCE)GetWindowLong (hWnd, GWL_HINSTANCE),
                             NULL);
   return 0;
}

//==============================================================================
// Funktion der Client-Area, wird von WndProc aufgerufen
//==============================================================================
#pragma argsused
LRESULT fnWMDestroy (HWND hWnd, WPARAM wParam, LPARAM lParam)
{
   PostQuitMessage (0);
   KillTimer (hWnd, ID_TIMER);
   return 0;
}

//==============================================================================
// Funktion der Client-Area, wird von WndProc aufgerufen
//==============================================================================
#pragma argsused
LRESULT fnWMSize (HWND hWnd, WPARAM wParam, LPARAM lParam)
{
  int nActWidth  = LOWORD(lParam);
  int nMinWidth  = 50 * nSmallCharWidth;
  int nActHeight = HIWORD(lParam);
  int nMinHeight =  7 * nCharHeight;
  int nNewWidth  = nActWidth  < nMinWidth  ? nMinWidth  : nActWidth;
  int nNewHeight = nActHeight < nMinHeight ? nMinHeight : nActHeight;

  if ((nActWidth < nNewWidth) || (nActHeight < nNewHeight))
  {
    nNewWidth  = nNewWidth  + GetSystemMetrics (SM_CXFRAME) * 2;
    nNewHeight = nNewHeight + GetSystemMetrics (SM_CYFRAME) * 2
                            + GetSystemMetrics (SM_CYMENU)
                            + GetSystemMetrics (SM_CYCAPTION);
    MoveWindow (hWnd, 0, 0, nNewWidth, nNewHeight, TRUE);
  }

  //----------------------------------------------------------------------------
  // globale variablen setzten
  //----------------------------------------------------------------------------
  nAnzZeichen = nNewWidth  / nSmallCharWidth - 2;
  nAnzZeilen  = nNewHeight / nCharHeight     - 4;

  //----------------------------------------------------------------------------
  // abhnge Unterfenster skalieren
  //----------------------------------------------------------------------------
  MoveWindow(hStatic_1, 0, nActHeight-nCharHeight, nActWidth, nCharHeight, TRUE);

  return 0;
}

//==============================================================================
// Funktion der Client-Area, wird von WndProc aufgerufen
//==============================================================================
#pragma argsused
LRESULT fnWMTimer (HWND hWnd, WPARAM wParam, LPARAM lParam)
{
   char        sTime [10] = "";
   struct time aTime;
   gettime(&aTime);
   sprintf (sTime, "%02d:%02d.%02d", aTime.ti_hour, aTime.ti_min, aTime.ti_sec);

   SetWindowText (hStatic_1, sTime);
   return 0;
}

//==============================================================================
// Funktion zur Umrechnung von Werten
//==============================================================================
double fnCalcValue (double fValue, double fFaktor, bool bMultiply,
                    double fOffset, bool bAddOffset, bool bOffsetFirst)
{
   if (fFaktor != 0.0)
   {
     if (bOffsetFirst)
     {
        fValue = fValue + (bAddOffset ? fOffset : -fOffset);
        fValue = fValue * (bMultiply  ? fFaktor : 1/fFaktor);
     }
     else
     {
        fValue = fValue * (bMultiply  ? fFaktor : 1/fFaktor);
        fValue = fValue + (bAddOffset ? fOffset : -fOffset);
     }
   }
   else
   {
      fValue = 0.0;
   }
   return fValue;
}

//==============================================================================
// Funktion zur Umrechnung von Werten
//==============================================================================
void fnValueTable (HDC hDC)
{
   int nLine = 0;
   int nPos;
   int j = 0;
   double f = fStartwert;
   char sText [100]    = "";
   UINT nOldSettings = SetTextAlign (hDC, TA_RIGHT | TA_TOP);
   HPEN hPen, hOldPen;
   int nStellen = 2*nStellenVK+5;

   hPen    = CreatePen (PS_SOLID, 1, RGB (0, 0, 0));
   hOldPen = (HPEN)SelectObject (hDC, hPen);

   while (((j+1)*nStellen) < nAnzZeichen)
   {
      nLine = 0;
      nPos = nSmallCharWidth + j * nStellen * nSmallCharWidth;
      for (nLine=0; nLine<nAnzZeilen; f+=fSchrittweite, nLine++)
      {
         sprintf (sText, "%*.*lf =", nStellenVK, nStellenNK, f);
         TextOut (hDC, nPos+(nStellenVK+2)*nSmallCharWidth, (nLine+2)*nCharHeight,
                  sText, strlen (sText));

         sprintf (sText, "%*.*lf", nStellenVK, nStellenNK, fnCalcValue(f, fFaktor, bMultiply, fOffset,
                  bAddOffset, bOffsetFirst));
         TextOut (hDC, nPos+(nStellen-2)*nSmallCharWidth, (nLine+2)*nCharHeight,
                  sText, strlen (sText));
      }

      MoveToEx (hDC, j*nStellen*nSmallCharWidth, 2*nCharHeight, NULL);
      LineTo   (hDC, j*nStellen*nSmallCharWidth, (nLine+2)*nCharHeight);
      j++;
   }
   SelectObject (hDC, hOldPen);
   SetTextAlign (hDC, nOldSettings);
   DeleteObject (hPen);
}

