//******************************************************************************
// WIN_13.cpp - ffnet eine eigene Client-Area und gibt dort einen Text aus
//******************************************************************************
#include <windows.h>
#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include "Win_13.rh"
#include <condefs.h> // spezifisch: Borland C++ Builder

//==============================================================================
// Funktionsprototypen
//==============================================================================
USERC("Win_13.rc");  // spezifisch: Borland C++ Builder
//---------------------------------------------------------------------------
LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM);

LRESULT fnWMCommand (HWND, WPARAM, LPARAM);
LRESULT fnWMCreate  (HWND, WPARAM, LPARAM);
LRESULT fnWMDestroy (HWND, WPARAM, LPARAM);
LRESULT fnWMPaint   (HWND, WPARAM, LPARAM);
LRESULT fnWMSize    (HWND, WPARAM, LPARAM);
LRESULT fnWMTimer   (HWND, WPARAM, LPARAM);

//------------------------------------------------------------------------------
void   fnValueTable (HDC hDC);
double fnCalcValue  (double fValue, double fFaktor=1.0, bool bMultiply=true,
                     double fOffset=0.0, bool bAddOffset=false,
                     bool bOffsetFirst=true);

//==============================================================================
// Symbolische Konstanten
//==============================================================================
#define TIM_ZEIT        10000
#define L_ZEIT          10001
#define E_START         10002
#define E_SCHRITT       10003
#define CK_NACHKOMMA    10004
#define CB_NACHKOMMA    10005
#define CB_VORKOMMA     10006
#define L_START         10007
#define L_SCHRITT       10008
#define L_VORNACHKOMMA  10009
#define L_HINTERGRUND   10010

#define EINHEITTEXTLEN 100

//==============================================================================
// globale Variablen
//==============================================================================
int nAnzZeichen, nAnzZeilen;
int nSmallCharWidth, nBigCharWidth, nCharHeight;
char sEinheit1 [EINHEITTEXTLEN] = "Zoll";
char sEinheit2 [EINHEITTEXTLEN] = "cm";
double fFaktor       = 2.56;
bool   bMultiply     = true;
double fOffset       = 0.0;
bool   bAddOffset    = false;
bool   bOffsetFirst  = false;
double fSchrittweite = 1.0;
double fStartwert    = 0.0;
int    nStellenVK    =  10;
int    nStellenNK    =   2;
bool   bStellenNK    = true;

const char sWindowclassname [] = "Win_13";
HWND       hWindow;
HWND       hLZeit;
HWND       hEStart;
HWND       hESchritt;
HWND       hCKNachkomma;
HWND       hCBNachkomma;
HWND       hCBVorkomma;
HWND       hLStart;
HWND       hLSchritt;
HWND       hLVorNachkomma;
HWND       hLHintergrund;

//==============================================================================
// Hauptprogramm
//==============================================================================
#pragma argsused
WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdParam,
                    int nCmdShow)
{
   MSG      aMessage;
   WNDCLASS aWindowclass;

   if (!hPrevInstance)
   {
      aWindowclass.style         = CS_HREDRAW | CS_VREDRAW;
      aWindowclass.lpfnWndProc   = WndProc;
      aWindowclass.cbClsExtra    = 0;
      aWindowclass.cbWndExtra    = 0;
      aWindowclass.hInstance     = hInstance;
      aWindowclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION);
      aWindowclass.hCursor       = LoadCursor (NULL, IDC_ARROW);
      aWindowclass.hbrBackground = (HBRUSH) GetStockObject (WHITE_BRUSH);
      aWindowclass.lpszMenuName  = MAKEINTRESOURCE(IDM_MENU1);
      aWindowclass.lpszClassName = sWindowclassname;

      if (!RegisterClass (&aWindowclass))
      {
         MessageBox (NULL,"Registrierung nicht mglich",sWindowclassname,MB_OK);
         return 0;
      }
   }

   //---------------------------------------------------------------------------
   hWindow = CreateWindow (sWindowclassname, "Umrechner", WS_OVERLAPPEDWINDOW,
                           CW_USEDEFAULT, CW_USEDEFAULT,
                           CW_USEDEFAULT, CW_USEDEFAULT,
                           NULL, NULL, hInstance, NULL);
   if (!hWindow)
   {
      MessageBox (NULL, "Fenster nicht erzeugbar", sWindowclassname, MB_OK);
      return 0;
   }

   //---------------------------------------------------------------------------
   if (!SetTimer (hWindow, TIM_ZEIT, 1000, NULL))
   {
      MessageBox (hWindow, "Zuviele Timer!", sWindowclassname,
                  MB_ICONEXCLAMATION | MB_RETRYCANCEL);
      return 0;
   }

   //---------------------------------------------------------------------------
   ShowWindow (hWindow, nCmdShow);
   if (!UpdateWindow (hWindow))
   {
      MessageBox (NULL, "WM_PAINT fehlgeschlagen", sWindowclassname, MB_OK);
      return 0;
   }

   //---------------------------------------------------------------------------
   while (GetMessage (&aMessage, NULL, 0, 0))
   {
      TranslateMessage (&aMessage);
      DispatchMessage (&aMessage);
   }
   return aMessage.wParam;
}

//==============================================================================
// Handlerfunktion der Client-Area, wird von DispatchMessage aufgerufen.
//==============================================================================
#pragma argsused
LRESULT CALLBACK WndProc (HWND hWnd, UINT nMsg, WPARAM wParam, LPARAM lParam)
{
   switch (nMsg)
   {
      case WM_COMMAND: return fnWMCommand (hWnd, wParam, lParam);
      case WM_CREATE:  return fnWMCreate  (hWnd, wParam, lParam);
      case WM_DESTROY: return fnWMDestroy (hWnd, wParam, lParam);
      case WM_PAINT:   return fnWMPaint   (hWnd, wParam, lParam);
      case WM_SIZE:    return fnWMSize    (hWnd, wParam, lParam);
      case WM_TIMER:   return fnWMTimer   (hWnd, wParam, lParam);
   }
   return DefWindowProc (hWnd, nMsg, wParam, lParam);
}

//==============================================================================
// Funktion der Client-Area, wird von WndProc aufgerufen
//==============================================================================
#pragma argsused
LRESULT fnWMPaint (HWND hWnd, WPARAM wParam, LPARAM lParam)
{
   HDC         hDC ;
   PAINTSTRUCT aPS ;
   RECT        aRectTitel;
   char        sUeberschrift [2*EINHEITTEXTLEN + 50];
   HBRUSH      hBlueBrush;
   HFONT       hFont, hOldFont;
   int         nOldBk;
   COLORREF    nOldTxtCol;

   //---------------------------------------------------------------------------
   // berschrift
   //---------------------------------------------------------------------------
   GetClientRect (hWnd, &aRectTitel);
   aRectTitel.bottom = aRectTitel.top + 1.5 * nCharHeight;
   hBlueBrush = CreateSolidBrush (RGB (100, 100, 255));
   hFont      = CreateFont (nCharHeight, 0, 0, 0, FW_THIN, FALSE, FALSE, FALSE,
                            ANSI_CHARSET, OUT_DEFAULT_PRECIS,
                            CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
                            DEFAULT_PITCH, "Braggadocio");
   sprintf (sUeberschrift, "Umrechnung von %s nach %s", sEinheit1, sEinheit2);

   //---------------------------------------------------------------------------
   hDC = BeginPaint (hWnd, &aPS);

   FillRect (hDC, &aRectTitel, hBlueBrush);
   FrameRect(hDC, &aRectTitel, (HBRUSH)GetStockObject (BLACK_BRUSH));

   hOldFont   = (HFONT)SelectObject (hDC, hFont);
   nOldBk     = SetBkMode (hDC, TRANSPARENT);
   nOldTxtCol = SetTextColor (hDC, RGB (255,255,0));
   DrawText (hDC, sUeberschrift, -1, &aRectTitel, DT_SINGLELINE|DT_CENTER|DT_VCENTER);
   SetTextColor (hDC, nOldTxtCol);
   SetBkMode    (hDC, nOldBk);
   SelectObject (hDC, hOldFont);

   fnValueTable(hDC);
   EndPaint (hWnd, &aPS);

   //---------------------------------------------------------------------------
   // Limitierte Resourcen wieder freigeben
   //---------------------------------------------------------------------------
   DeleteObject (hBlueBrush);
   DeleteObject (hFont);

   return 0;
}

//==============================================================================
// Funktion der Client-Area, wird von WndProc aufgerufen
//==============================================================================
#pragma argsused
LRESULT fnWMCommand (HWND hWnd, WPARAM wParam, LPARAM lParam)
{
  WORD wID           = LOWORD(wParam);
  WORD wNotification = HIWORD(wParam);
  
  switch (wID)
  {
    case  E_START:
          if (wNotification == EN_KILLFOCUS)
          {
            char sTemp [101] = "";
            GetWindowText ((HWND)lParam, sTemp, 100);
            fStartwert = atof (sTemp);
            InvalidateRect (hWnd, NULL, TRUE);
            return 0;
          }
          break;

    case  E_SCHRITT:
          if (wNotification == EN_KILLFOCUS)
          {
            char sTemp [101] = "";
            GetWindowText ((HWND)lParam, sTemp, 100);
            fSchrittweite = atof (sTemp);
            InvalidateRect (hWnd, NULL, TRUE);
            return 0;
          }
          break;

    case  CK_NACHKOMMA:
          if (wNotification == BN_CLICKED)
          {
            LRESULT nCheck;
            nCheck = SendMessage ((HWND)lParam, BM_GETCHECK, (WPARAM)0, (LPARAM)0);
            bStellenNK = nCheck == BST_CHECKED;
            InvalidateRect (hWnd, NULL, TRUE);
            return 0;
          }
          break;

    case  CB_NACHKOMMA:
          if (wNotification == CBN_SELCHANGE)
          {
            LRESULT nIndex;
            char sTemp [101] = "";
            nIndex = SendMessage ((HWND)lParam, CB_GETCURSEL,(WPARAM)0,(LPARAM)0);
            SendMessage ((HWND)lParam, CB_GETLBTEXT,(WPARAM)nIndex,(LPARAM)(LPCSTR)sTemp);
            nStellenNK = atoi (sTemp);
            InvalidateRect (hWnd, NULL, TRUE);
            return 0;
          }
          break;

    case  CB_VORKOMMA:
          if (wNotification == CBN_SELCHANGE)
          {
            LRESULT nIndex;
            char sTemp [101] = "";
            nIndex = SendMessage ((HWND)lParam, CB_GETCURSEL,(WPARAM)0,(LPARAM)0);
            SendMessage ((HWND)lParam, CB_GETLBTEXT,(WPARAM)nIndex,(LPARAM)(LPCSTR)sTemp);
            nStellenVK = atoi (sTemp);
            InvalidateRect (hWnd, NULL, TRUE);
            return 0;
          }
          break;

    case  IDM_ZOLLCM:
          strcpy (sEinheit1, "Zoll");
          strcpy (sEinheit2, "cm");
          fFaktor      = 2.56;
          bMultiply    = true;
          fOffset      = 0.0;
          bAddOffset   = false;
          bOffsetFirst = false;
          InvalidateRect (hWnd, NULL, TRUE);
          return 0;

    case  IDM_CMZOLL:
          strcpy (sEinheit1, "cm");
          strcpy (sEinheit2, "Zoll");
          fFaktor      = 2.56;
          bMultiply    = false;
          fOffset      = 0.0;
          bAddOffset   = false;
          bOffsetFirst = false;
          InvalidateRect (hWnd, NULL, TRUE);
          return 0;

    case  IDM_CELSIUSFAHRENHEIT:
          strcpy (sEinheit1, "Celsius");
          strcpy (sEinheit2, "Fahrenheit");
          fFaktor      = 5.0/9.0;
          bMultiply    = false;
          fOffset      = 32.0;
          bAddOffset   = true;
          bOffsetFirst = false;
          InvalidateRect (hWnd, NULL, TRUE);
          return 0;

    case  IDM_FAHRENHEITCELSIUS:
          strcpy (sEinheit1, "Fahrenheit");
          strcpy (sEinheit2, "Celsius");
          fFaktor      = 5.0/9.0;
          bMultiply    = true;
          fOffset      = 32.0;
          bAddOffset   = false;
          bOffsetFirst = true;
          InvalidateRect (hWnd, NULL, TRUE);
          return 0;
  }
  return DefWindowProc (hWnd, WM_COMMAND, wParam, lParam);
}

//==============================================================================
// Funktion der Client-Area, wird von WndProc aufgerufen
//==============================================================================
#pragma argsused
LRESULT fnWMCreate (HWND hWnd, WPARAM wParam, LPARAM lParam)
{
   TEXTMETRIC aTM;
   char sTemp [255] = "";
   int nTemp;
   LRESULT nIndex;
   HDC hDC = GetDC (hWnd) ;

   GetTextMetrics (hDC, &aTM) ;
   ReleaseDC (hWnd, hDC) ;

   nCharHeight     = aTM.tmHeight + aTM.tmExternalLeading;
   nSmallCharWidth = aTM.tmAveCharWidth;
   nBigCharWidth   = (aTM.tmPitchAndFamily & TMPF_FIXED_PITCH ? 3 : 2) *
                      aTM.tmAveCharWidth / 2;

   hLHintergrund  = CreateWindow ("static", "",
                    WS_CHILD | WS_VISIBLE,
                    0, 0, 0, 0, hWnd, (HMENU)L_HINTERGRUND,
                    (HINSTANCE)GetWindowLong (hWnd, GWL_HINSTANCE), NULL);
   hLZeit         = CreateWindow ("static", "Uhrzeit",
                    WS_CHILD | WS_VISIBLE | SS_RIGHT,
                    0, 0, 0, 0, hWnd, (HMENU)L_ZEIT,
                    (HINSTANCE)GetWindowLong (hWnd, GWL_HINSTANCE), NULL);
   hLStart        = CreateWindow ("static", "Startwert",
                    WS_CHILD | WS_VISIBLE | SS_LEFT,
                    0, 0, 0, 0, hWnd, (HMENU)L_START,
                    (HINSTANCE)GetWindowLong (hWnd, GWL_HINSTANCE), NULL);
   hEStart        = CreateWindow ("edit", "",
                    ES_RIGHT | WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
                    0, 0, 0, 0, hWnd, (HMENU)E_START,
                    (HINSTANCE)GetWindowLong (hWnd, GWL_HINSTANCE), NULL);
   hLSchritt      = CreateWindow ("static", "Schrittweite",
                    WS_CHILD | WS_VISIBLE | SS_LEFT,
                    0, 0, 0, 0, hWnd, (HMENU)L_SCHRITT,
                    (HINSTANCE)GetWindowLong (hWnd, GWL_HINSTANCE), NULL);
   hESchritt      = CreateWindow ("edit", "",
                    ES_RIGHT | WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
                    0, 0, 0, 0, hWnd, (HMENU)E_SCHRITT,
                    (HINSTANCE)GetWindowLong (hWnd, GWL_HINSTANCE), NULL);
   hLVorNachkomma = CreateWindow ("static", "Vor-/Nachkommastellen",
                    WS_CHILD | WS_VISIBLE | SS_LEFT,
                    0, 0, 0, 0, hWnd, (HMENU)L_VORNACHKOMMA,
                    (HINSTANCE)GetWindowLong (hWnd, GWL_HINSTANCE), NULL);
   hCBVorkomma    = CreateWindow ("combobox", NULL,
                    CBS_DROPDOWNLIST | WS_CHILD | WS_VISIBLE | WS_TABSTOP |
                    WS_VSCROLL,
                    0, 0, 0, 0, hWnd, (HMENU)CB_VORKOMMA,
                    (HINSTANCE)GetWindowLong (hWnd, GWL_HINSTANCE), NULL);
   hCBNachkomma   = CreateWindow ("combobox", NULL,
                    CBS_DROPDOWNLIST | WS_CHILD | WS_VISIBLE | WS_TABSTOP |
                    WS_VSCROLL,
                    0, 0, 0, 0, hWnd, (HMENU)CB_NACHKOMMA,
                    (HINSTANCE)GetWindowLong (hWnd, GWL_HINSTANCE), NULL);
   hCKNachkomma   = CreateWindow ("button", "Nachkomma",
                    BS_AUTOCHECKBOX | WS_CHILD | WS_VISIBLE | WS_TABSTOP,
                    0, 0, 0, 0, hWnd, (HMENU)CK_NACHKOMMA,
                    (HINSTANCE)GetWindowLong (hWnd, GWL_HINSTANCE), NULL);

   sprintf (sTemp, "%*.*lf", nStellenVK, nStellenNK, fStartwert);
   SetWindowText (hEStart, sTemp);

   sprintf (sTemp, "%*.*lf", nStellenVK, nStellenNK, fSchrittweite);
   SetWindowText (hESchritt, sTemp);

   SendMessage (hCKNachkomma, BM_SETCHECK, (WPARAM)(bStellenNK ? TRUE : FALSE), (LPARAM)0);

   SendMessage (hCBVorkomma, CB_ADDSTRING, (WPARAM)0, (LPARAM)(LPCTSTR)"1");
   SendMessage (hCBVorkomma, CB_ADDSTRING, (WPARAM)0, (LPARAM)(LPCTSTR)"2");
   SendMessage (hCBVorkomma, CB_ADDSTRING, (WPARAM)0, (LPARAM)(LPCTSTR)"3");
   SendMessage (hCBVorkomma, CB_ADDSTRING, (WPARAM)0, (LPARAM)(LPCTSTR)"4");
   SendMessage (hCBVorkomma, CB_ADDSTRING, (WPARAM)0, (LPARAM)(LPCTSTR)"5");
   SendMessage (hCBVorkomma, CB_ADDSTRING, (WPARAM)0, (LPARAM)(LPCTSTR)"6");
   SendMessage (hCBVorkomma, CB_ADDSTRING, (WPARAM)0, (LPARAM)(LPCTSTR)"7");
   SendMessage (hCBVorkomma, CB_ADDSTRING, (WPARAM)0, (LPARAM)(LPCTSTR)"8");
   SendMessage (hCBVorkomma, CB_ADDSTRING, (WPARAM)0, (LPARAM)(LPCTSTR)"9");
   SendMessage (hCBVorkomma, CB_ADDSTRING, (WPARAM)0, (LPARAM)(LPCTSTR)"10");

   nTemp = nStellenVK - nStellenNK - 1;
   nTemp = nTemp > 1 ? nTemp : 1;
   sprintf (sTemp, "%d", nTemp);
   nIndex = SendMessage (hCBVorkomma, CB_FINDSTRING, (WPARAM)-1, (LPARAM)(LPCSTR)sTemp);
   SendMessage (hCBVorkomma, CB_SETCURSEL, (WPARAM)nIndex, (LPARAM)0);

   SendMessage (hCBNachkomma, CB_ADDSTRING, (WPARAM)0, (LPARAM)(LPCTSTR)"1");
   SendMessage (hCBNachkomma, CB_ADDSTRING, (WPARAM)0, (LPARAM)(LPCTSTR)"2");
   SendMessage (hCBNachkomma, CB_ADDSTRING, (WPARAM)0, (LPARAM)(LPCTSTR)"3");
   SendMessage (hCBNachkomma, CB_ADDSTRING, (WPARAM)0, (LPARAM)(LPCTSTR)"4");
   SendMessage (hCBNachkomma, CB_ADDSTRING, (WPARAM)0, (LPARAM)(LPCTSTR)"5");
   SendMessage (hCBNachkomma, CB_ADDSTRING, (WPARAM)0, (LPARAM)(LPCTSTR)"6");

   sprintf (sTemp, "%d", nStellenNK);
   nIndex = SendMessage (hCBNachkomma, CB_FINDSTRING, (WPARAM)-1, (LPARAM)(LPCSTR)sTemp);
   SendMessage (hCBNachkomma, CB_SETCURSEL, (WPARAM)nIndex, (LPARAM)0);
   return 0;
}

//==============================================================================
// Funktion der Client-Area, wird von WndProc aufgerufen
//==============================================================================
#pragma argsused
LRESULT fnWMDestroy (HWND hWnd, WPARAM wParam, LPARAM lParam)
{
   PostQuitMessage (0);
   KillTimer (hWnd, TIM_ZEIT);
   return 0;
}

//==============================================================================
// Funktion der Client-Area, wird von WndProc aufgerufen
//==============================================================================
#pragma argsused
LRESULT fnWMSize (HWND hWnd, WPARAM wParam, LPARAM lParam)
{
  int nActWidth  = LOWORD(lParam);
  int nMinWidth  = 105 * nSmallCharWidth;
  int nActHeight = HIWORD(lParam);
  int nMinHeight =  7 * nCharHeight;
  int nNewWidth  = nActWidth  < nMinWidth  ? nMinWidth  : nActWidth;
  int nNewHeight = nActHeight < nMinHeight ? nMinHeight : nActHeight;

  //----------------------------------------------------------------------------
  // globale variablen setzten
  //----------------------------------------------------------------------------
  nAnzZeichen = nNewWidth  / nSmallCharWidth - 2;
  nAnzZeilen  = nNewHeight / nCharHeight     - 4;

  //----------------------------------------------------------------------------
  // abhnge Unterfenster skalieren
  //----------------------------------------------------------------------------
  MoveWindow(hLStart,                         0, nActHeight-nCharHeight-4, nSmallCharWidth* 9, nCharHeight,   TRUE);
  MoveWindow(hEStart,        nSmallCharWidth* 9, nActHeight-nCharHeight-6, nSmallCharWidth*10, nCharHeight+4, TRUE);
  MoveWindow(hLSchritt,      nSmallCharWidth*22, nActHeight-nCharHeight-4, nSmallCharWidth*12, nCharHeight,   TRUE);
  MoveWindow(hESchritt,      nSmallCharWidth*34, nActHeight-nCharHeight-6, nSmallCharWidth*10, nCharHeight+4, TRUE);
  MoveWindow(hLVorNachkomma, nSmallCharWidth*47, nActHeight-nCharHeight-4, nSmallCharWidth*22, nCharHeight,   TRUE);
  MoveWindow(hCBVorkomma,    nSmallCharWidth*70, nActHeight-nCharHeight-8, nSmallCharWidth* 5, nCharHeight*5, TRUE);
  MoveWindow(hCBNachkomma,   nSmallCharWidth*75, nActHeight-nCharHeight-8, nSmallCharWidth* 5, nCharHeight*5, TRUE);
  MoveWindow(hCKNachkomma,   nSmallCharWidth*80, nActHeight-nCharHeight-4, nSmallCharWidth*15, nCharHeight,   TRUE);
  MoveWindow(hLZeit,         nSmallCharWidth*95, nActHeight-nCharHeight-4, nActWidth-nSmallCharWidth*95, nCharHeight, TRUE);
  MoveWindow(hLHintergrund,                   0, nActHeight-nCharHeight-8, nActWidth,          nCharHeight+8, TRUE);

  if ((nActWidth < nNewWidth) || (nActHeight < nNewHeight))
  {
    nNewWidth  = nNewWidth  + GetSystemMetrics (SM_CXFRAME) * 2;
    nNewHeight = nNewHeight + GetSystemMetrics (SM_CYFRAME) * 2
                            + GetSystemMetrics (SM_CYMENU)
                            + GetSystemMetrics (SM_CYCAPTION);
    MoveWindow (hWnd, 0, 0, nNewWidth, nNewHeight, TRUE);
  }
  return 0;
}

//==============================================================================
// Funktion der Client-Area, wird von WndProc aufgerufen
//==============================================================================
#pragma argsused
LRESULT fnWMTimer (HWND hWnd, WPARAM wParam, LPARAM lParam)
{
   char        sTime [10] = "";
   struct time aTime;
   gettime(&aTime);
   sprintf (sTime, "%02d:%02d.%02d", aTime.ti_hour, aTime.ti_min, aTime.ti_sec);

   SetWindowText (hLZeit, sTime);
   return 0;
}

//==============================================================================
// Funktion zur Umrechnung von Werten
//==============================================================================
double fnCalcValue (double fValue, double fFaktor, bool bMultiply,
                    double fOffset, bool bAddOffset, bool bOffsetFirst)
{
   if (fFaktor != 0.0)
   {
     if (bOffsetFirst)
     {
        fValue = fValue + (bAddOffset ? fOffset : -fOffset);
        fValue = fValue * (bMultiply  ? fFaktor : 1/fFaktor);
     }
     else
     {
        fValue = fValue * (bMultiply  ? fFaktor : 1/fFaktor);
        fValue = fValue + (bAddOffset ? fOffset : -fOffset);
     }
   }
   else
   {
      fValue = 0.0;
   }
   return fValue;
}

//==============================================================================
// Funktion zur Umrechnung von Werten
//==============================================================================
void fnValueTable (HDC hDC)
{
   int nLine, nPos, j = 0;
   double f = fStartwert;
   char sText [100]    = "";
   UINT nOldSettings = SetTextAlign (hDC, TA_RIGHT | TA_TOP);
   HPEN hPen, hOldPen;
   int nStellen = 2*nStellenVK+5;

   hPen    = CreatePen (PS_SOLID, 1, RGB (0, 0, 0));
   hOldPen = (HPEN)SelectObject (hDC, hPen);

   while (((j+1)*nStellen) < nAnzZeichen)
   {
      nPos = nSmallCharWidth + j * nStellen * nSmallCharWidth;
      for (nLine=0; nLine<nAnzZeilen; f+=fSchrittweite, nLine++)
      {
         sprintf (sText, "%*.*lf =",
                  nStellenVK, bStellenNK ? nStellenNK : 0, f);
         TextOut (hDC, nPos+(nStellenVK+2)*nSmallCharWidth,
                  (nLine+2)*nCharHeight, sText, strlen (sText));

         sprintf (sText, "%*.*lf", nStellenVK,
                  bStellenNK ? nStellenNK : 0, fnCalcValue(f, fFaktor,
                  bMultiply, fOffset, bAddOffset, bOffsetFirst));
         TextOut (hDC, nPos+(nStellen-2)*nSmallCharWidth, (nLine+2)*nCharHeight,
                  sText, strlen (sText));
      }

      MoveToEx (hDC, j*nStellen*nSmallCharWidth, 2*nCharHeight, NULL);
      LineTo   (hDC, j*nStellen*nSmallCharWidth, (nLine+2)*nCharHeight);
      j++;
   }
   SelectObject (hDC, hOldPen);
   SetTextAlign (hDC, nOldSettings);
   DeleteObject (hPen);
}

